/*
 * OrderManagementBean.java
 *
 * Created on Nov 17, 2007, 3:37:38 PM
 *
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ch.unifr.ase.transactions.services;

import ch.unifr.ase.model.Customer;
import ch.unifr.ase.model.Product;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.annotation.Resource;
import javax.ejb.SessionContext;
import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.ejb.TransactionManagement;
import javax.jws.WebService;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.transaction.HeuristicMixedException;
import javax.transaction.HeuristicRollbackException;
import javax.transaction.RollbackException;
import javax.transaction.SystemException;

/**
 *
 * @author oliechti
 */
@Stateless
@WebService
public class OrderManagementBean implements OrderManagementRemote, OrderManagementLocal {

    @Resource
    private SessionContext sctx;
    @PersistenceContext(unitName = "TransactionsSample-ejbPU2")
    EntityManager em;
    @PersistenceContext(unitName = "TransactionsSample-ejbPU")
    EntityManager emCustomers;

    @TransactionAttribute(value = TransactionAttributeType.REQUIRED)
    public void createProduct(String description, long price, int quantity) {
        Product p = new Product();
        p.setDescription(description);
        p.setPrice(price);
        p.setAvailableQuantity(quantity);
        em.persist(p);
    }

    public void createCustomer(String firstName, String lastName, int amountDue) {
        Customer c = new Customer();
        c.setFirstName(firstName);
        c.setLastName(lastName);
        c.setAmountDue(amountDue);
        emCustomers.persist(c);
    }

    public void processOrder(long customerId, long productId, int quantity) {
        Customer c = emCustomers.find(Customer.class, customerId);
        Product p = em.find(Product.class, productId);
        if (c == null || p == null) {
            throw new RuntimeException("bad params");
        }
        c.setAmountDue(c.getAmountDue() + quantity * p.getPrice());
        p.setAvailableQuantity(p.getAvailableQuantity() - quantity);
        if (p.getAvailableQuantity() < 0) {
            System.out.println("not enough stock");
            sctx.setRollbackOnly();
            //throw new RuntimeException("not enough stock!");
        }
    }
    // Add business logic below. (Right-click in editor and choose
    // "EJB Methods > Add Business Method" or "Web Service > Add Operation")
}