/*
 * Main.java
 *
 * Created on Nov 20, 2007, 3:24:00 PM
 *
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ch.unifr.ase.transactions;

import ch.unifr.ase.model.Customer;
import ch.unifr.ase.model.Product;
import ch.unifr.ase.transactions.services.OrderManagementRemote;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.annotation.Resource;
import javax.ejb.EJB;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.PersistenceUnit;
import javax.transaction.HeuristicMixedException;
import javax.transaction.HeuristicRollbackException;
import javax.transaction.NotSupportedException;
import javax.transaction.RollbackException;
import javax.transaction.SystemException;
import javax.transaction.UserTransaction;

/**
 *
 * @author oliechti
 */
public class Main {

    @EJB
    private static OrderManagementRemote orderManagementBean;
    @Resource
    private static UserTransaction utx;
    @PersistenceUnit(unitName = "TransactionsSample-ejbPU")
    static EntityManagerFactory customersEmf;
    @PersistenceUnit(unitName = "TransactionsSample-ejbPU2")
    static EntityManagerFactory productsEmf;

    private void test2() {
        try {
            System.out.println("utx status: " + utx.getStatus());
            utx.begin();
            System.out.println("utx status: " + utx.getStatus());
            System.out.println("calling ejb, " + utx.getStatus());
            orderManagementBean.createProduct("test2 createdByEJBC " + new java.util.Date(), -1, 5678);
            System.out.println("utx status: " + utx.getStatus());
            System.out.println("calling commit()... ");
            utx.commit();
            System.out.println("utx status: " + utx.getStatus());
        } catch (Exception ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    private void test() {
        EntityManager em = customersEmf.createEntityManager();
        EntityManager em2 = productsEmf.createEntityManager();
        try {
            utx.begin();
            em.joinTransaction();
            em2.joinTransaction();

            String msg = new java.util.Date().toString();
            System.out.println(" calling EJB");
            orderManagementBean.createProduct(msg + " createdByEJBC", -1, 1234);
            System.out.println(" done.");

            String cn = new java.util.Date().toString();
            System.out.println("creating customer " + cn);
            Customer c = new Customer();
            c.setFirstName("TheClient");
            c.setLastName(cn);
            c.setAmountDue(0);
            em.persist(c);


            System.out.println("creating product " + msg);
            Product p = new Product();
            p.setDescription("Product " + msg);
            em2.persist(p);


            long rnd = (long) (Math.random() * 4);
            if (rnd >= 0) {
                System.out.println("Commit");
                utx.commit();
            } else if (rnd == -1) {
                System.out.println("Rollback");
                utx.rollback();
            } else {
                System.out.println("Rollback");
                utx.rollback();
            }

            em.close();
            em2.close();
        } catch (RollbackException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        } catch (HeuristicMixedException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        } catch (HeuristicRollbackException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        } catch (SecurityException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalStateException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        } catch (NotSupportedException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        } catch (SystemException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        System.out.println("Starting JavaEE client...");
        System.out.println("Injected user transaction: " + utx);
        Main main = new Main();
        for (int i = 0; i < 100; i++) {
            main.test2();
        }
        System.out.print("done");
    }
}